#!/bin/bash

# substitutions that should occur before running:
# 
#   afwqrdsf234234 - root path of module, where files are currently
#   asdas7867652 - final path of bin file
#   876uyghjhsadadsf - name of service
#   u7a6ajshgdjbhdasf - port number
#	7i6jhgjasdsadassda - exports of environment variables
# 

set -e

# add user to run the service
adduser --system --group 876uyghjhsadadsf

# copy files
mkdir /lib/876uyghjhsadadsf
cp -Rf afwqrdsf234234* /lib/876uyghjhsadadsf
find /lib/876uyghjhsadadsf -type f -print0 | xargs -I {} -0 chmod 0664 {}
find /lib/876uyghjhsadadsf -type d -print0 | xargs -I {} -0 chmod 0775 {}
chmod +x asdas7867652
chown -R 876uyghjhsadadsf /lib/876uyghjhsadadsf

# setup bin link
ln -s asdas7867652 /usr/local/bin/perfectapi-876uyghjhsadadsf

# prepare log file
touch /var/log/876uyghjhsadadsf.log
chmod 0664 /var/log/876uyghjhsadadsf.log
chown 876uyghjhsadadsf /var/log/876uyghjhsadadsf.log

# create upstart script
cat >> /etc/init/876uyghjhsadadsf.conf <<EOF
# perfectapi job - autogenerated by perfectapi installer

author "Steven Campbell <steve@perfectapi.com>"
description "This job will start the 876uyghjhsadadsf service"
version "0.0.1"

respawn limit 10 5
respawn

start on runlevel [2345]
stop on runlevel [016]

script
	7i6jhgjasdsadassda
	
    exec sudo -H -E -u 876uyghjhsadadsf sh -c "/usr/local/bin/perfectapi-876uyghjhsadadsf server -p u7a6ajshgdjbhdasf >> /var/log/876uyghjhsadadsf.log 2>&1" 
end script

pre-start script
    # Date format same as (new Date()).toISOString() for consistency
    echo "[`date -u +%Y-%m-%dT%T.%3NZ`] Starting" >> /var/log/876uyghjhsadadsf.log
end script

pre-stop script

    echo "[`date -u +%Y-%m-%dT%T.%3NZ`] Stopping" >> /var/log/876uyghjhsadadsf.log
end script

EOF

# start the service
start 876uyghjhsadadsf
